Package org.apache.commons.math3.linear

# Class BlockFieldMatrix<T extends FieldElement<T>>

java.lang.Object
org.apache.commons.math3.linear.AbstractFieldMatrix<T>
org.apache.commons.math3.linear.BlockFieldMatrix<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  `Serializable`, `AnyMatrix`, `FieldMatrix<T>`

public class BlockFieldMatrix<T extends FieldElement<T>> extends AbstractFieldMatrix<T> implements Serializable
Cache-friendly implementation of FieldMatrix using a flat arrays to store square blocks of the matrix.

This implementation is specially designed to be cache-friendly. Square blocks are stored as small arrays and allow efficient traversal of data both in row major direction and columns major direction, one block at a time. This greatly increases performances for algorithms that use crossed directions loops like multiplication or transposition.

The size of square blocks is a static parameter. It may be tuned according to the cache size of the target computer processor. As a rule of thumbs, it should be the largest value that allows three blocks to be simultaneously cached (this is necessary for example for matrix multiplication). The default value is to use 36x36 blocks.

The regular blocks represent `BLOCK_SIZE` x `BLOCK_SIZE` squares. Blocks at right hand side and bottom side which may be smaller to fit matrix dimensions. The square blocks are flattened in row major order in single dimension arrays which are therefore `BLOCK_SIZE`2 elements long for regular blocks. The blocks are themselves organized in row major order.

As an example, for a block size of 36x36, a 100x60 matrix would be stored in 6 blocks. Block 0 would be a Field[1296] array holding the upper left 36x36 square, block 1 would be a Field[1296] array holding the upper center 36x36 square, block 2 would be a Field[1008] array holding the upper right 36x28 rectangle, block 3 would be a Field[864] array holding the lower left 24x36 rectangle, block 4 would be a Field[864] array holding the lower center 24x36 rectangle and block 5 would be a Field[672] array holding the lower right 24x28 rectangle.

The layout complexity overhead versus simple mapping of matrices to java arrays is negligible for small matrices (about 1%). The gain from cache efficiency leads to up to 3-fold improvements for matrices of moderate to large size.

Since:
  2.0
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`BLOCK_SIZE`
Block size.

## Constructor Summary

Constructors
Constructor
Description
`BlockFieldMatrix(int rows, int columns, T[][] blockData, boolean copyArray)`
Create a new dense matrix copying entries from block layout data.
`BlockFieldMatrix(Field<T> field, int rows, int columns)`
Create a new matrix with the supplied row and column dimensions.
`BlockFieldMatrix(T[][] rawData)`
Create a new dense matrix copying entries from raw layout data.

## Method Summary

Modifier and Type
Method
Description
`BlockFieldMatrix<T>`
`add(BlockFieldMatrix<T> m)`
Compute the sum of `this` and `m`.
`FieldMatrix<T>`
`add(FieldMatrix<T> m)`
Compute the sum of this and m.
`void`
`addToEntry(int row, int column, T increment)`
Change an entry in the specified row and column.
`FieldMatrix<T>`
`copy()`
Make a (deep) copy of this.
`static <T extends FieldElement<T>>
T[][]`
`createBlocksLayout(Field<T> field, int rows, int columns)`
Create a data array in blocks layout.
`FieldMatrix<T>`
`createMatrix(int rowDimension, int columnDimension)`
Create a new FieldMatrix<T> of the same type as the instance with the supplied row and column dimensions.
`T[]`
`getColumn(int column)`
Get the entries in column number `col` as an array.
`int`
`getColumnDimension()`
Returns the number of columns in the matrix.
`FieldMatrix<T>`
`getColumnMatrix(int column)`
Get the entries in column number `column` as a column matrix.
`FieldVector<T>`
`getColumnVector(int column)`
Returns the entries in column number `column` as a vector.
`T[][]`
`getData()`
Returns matrix entries as a two-dimensional array.
`T`
`getEntry(int row, int column)`
Returns the entry in the specified row and column.
`T[]`
`getRow(int row)`
Get the entries in row number `row` as an array.
`int`
`getRowDimension()`
Returns the number of rows in the matrix.
`FieldMatrix<T>`
`getRowMatrix(int row)`
Get the entries in row number `row` as a row matrix.
`FieldVector<T>`
`getRowVector(int row)`
Get the entries in row number `row` as a vector.
`FieldMatrix<T>`
`getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)`
Get a submatrix.
`BlockFieldMatrix<T>`
`multiply(BlockFieldMatrix<T> m)`
Returns the result of postmultiplying `this` by `m`.
`FieldMatrix<T>`
`multiply(FieldMatrix<T> m)`
Postmultiply this matrix by `m`.
`void`
`multiplyEntry(int row, int column, T factor)`
Change an entry in the specified row and column.
`T[]`
`operate(T[] v)`
Returns the result of multiplying this by the vector `v`.
`T[]`
`preMultiply(T[] v)`
Returns the (row) vector result of premultiplying this by the vector `v`.
`FieldMatrix<T>`
`scalarAdd(T d)`
Increment each entry of this matrix.
`FieldMatrix<T>`
`scalarMultiply(T d)`
Multiply each entry by `d`.
`void`
`setColumn(int column, T[] array)`
Set the entries in column number `column` as a column matrix.
`void`
`setColumnMatrix(int column, FieldMatrix<T> matrix)`
Set the entries in column number `column` as a column matrix.
`void`
`setColumnVector(int column, FieldVector<T> vector)`
Set the entries in column number `column` as a vector.
`void`
`setEntry(int row, int column, T value)`
Set the entry in the specified row and column.
`void`
`setRow(int row, T[] array)`
Set the entries in row number `row` as a row matrix.
`void`
`setRowMatrix(int row, BlockFieldMatrix<T> matrix)`
Sets the entries in row number `row` as a row matrix.
`void`
`setRowMatrix(int row, FieldMatrix<T> matrix)`
Set the entries in row number `row` as a row matrix.
`void`
`setRowVector(int row, FieldVector<T> vector)`
Set the entries in row number `row` as a vector.
`void`
`setSubMatrix(T[][] subMatrix, int row, int column)`
Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array.
`BlockFieldMatrix<T>`
`subtract(BlockFieldMatrix<T> m)`
Compute `this - m`.
`FieldMatrix<T>`
`subtract(FieldMatrix<T> m)`
Subtract `m` from this matrix.
`static <T extends FieldElement<T>>
T[][]`
`toBlocksLayout(T[][] rawData)`
Convert a data array from raw layout to blocks layout.
`FieldMatrix<T>`
`transpose()`
Returns the transpose of this matrix.
`T`
`walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)`
Visit (and possibly change) all matrix entries using the fastest possible order.
`T`
`walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)`
Visit (and possibly change) some matrix entries using the fastest possible order.
`T`
`walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)`
Visit (but don't change) all matrix entries using the fastest possible order.
`T`
`walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)`
Visit (but don't change) some matrix entries using the fastest possible order.
`T`
`walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)`
Visit (and possibly change) all matrix entries in row order.
`T`
`walkInRowOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)`
Visit (and possibly change) some matrix entries in row order.
`T`
`walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)`
Visit (but don't change) all matrix entries in row order.
`T`
`walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn)`
Visit (but don't change) some matrix entries in row order.

### Methods inherited from class org.apache.commons.math3.linear.AbstractFieldMatrix

`buildArray, buildArray, checkAdditionCompatible, checkColumnIndex, checkMultiplicationCompatible, checkRowIndex, checkSubMatrixIndex, checkSubMatrixIndex, checkSubtractionCompatible, copySubMatrix, copySubMatrix, equals, extractField, extractField, getField, getSubMatrix, getTrace, hashCode, isSquare, operate, power, preMultiply, preMultiply, toString, walkInColumnOrder, walkInColumnOrder, walkInColumnOrder, walkInColumnOrder`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### BLOCK_SIZE

public static final int BLOCK_SIZE
Block size.

See Also:
  - Constant Field Values

## Constructor Details

### BlockFieldMatrix

public BlockFieldMatrix(Field<T> field, int rows, int columns) throws NotStrictlyPositiveException
Create a new matrix with the supplied row and column dimensions.

Parameters:
  `field` - Field to which the elements belong.
  `rows` - Number of rows in the new matrix.
  `columns` - Number of columns in the new matrix.
Throws:
  `NotStrictlyPositiveException` - if row or column dimension is not positive.

### BlockFieldMatrix

public BlockFieldMatrix(T[][] rawData) throws DimensionMismatchException
Create a new dense matrix copying entries from raw layout data.

The input array must already be in raw layout.

Calling this constructor is equivalent to call:

    matrix = new BlockFieldMatrix<T>(getField(), rawData.length, rawData[0].length,
                                       toBlocksLayout(rawData), false);

Parameters:
  `rawData` - Data for the new matrix, in raw layout.
Throws:
  `DimensionMismatchException` - if the `blockData` shape is inconsistent with block layout.
See Also:
  - `BlockFieldMatrix(int, int, FieldElement[][], boolean)`

### BlockFieldMatrix

public BlockFieldMatrix(int rows, int columns, T[][] blockData, boolean copyArray) throws DimensionMismatchException, NotStrictlyPositiveException
Create a new dense matrix copying entries from block layout data.

The input array must already be in blocks layout.

Parameters:
  `rows` - the number of rows in the new matrix
  `columns` - the number of columns in the new matrix
  `blockData` - data for new matrix
  `copyArray` - if true, the input array will be copied, otherwise it will be referenced
Throws:
  `DimensionMismatchException` - if the `blockData` shape is inconsistent with block layout.
  `NotStrictlyPositiveException` - if row or column dimension is not positive.
See Also:
  - `createBlocksLayout(Field, int, int)`
  - `toBlocksLayout(FieldElement[][])`
  - `BlockFieldMatrix(FieldElement[][])`

## Method Details

### toBlocksLayout

public static <T extends FieldElement<T>> T[][] toBlocksLayout(T[][] rawData) throws DimensionMismatchException
Convert a data array from raw layout to blocks layout.

Raw layout is the straightforward layout where element at row i and column j is in array element `rawData[i][j]`. Blocks layout is the layout used in `BlockFieldMatrix` instances, where the matrix is split in square blocks (except at right and bottom side where blocks may be rectangular to fit matrix size) and each block is stored in a flattened one-dimensional array.

This method creates an array in blocks layout from an input array in raw layout. It can be used to provide the array argument of the `BlockFieldMatrix(int, int, FieldElement[][], boolean)` constructor.

Type Parameters:
  `T` - Type of the field elements.
Parameters:
  `rawData` - Data array in raw layout.
Returns:
  a new data array containing the same entries but in blocks layout
Throws:
  `DimensionMismatchException` - if `rawData` is not rectangular (not all rows have the same length).
See Also:
  - `createBlocksLayout(Field, int, int)`
  - `BlockFieldMatrix(int, int, FieldElement[][], boolean)`

### createBlocksLayout

public static <T extends FieldElement<T>> T[][] createBlocksLayout(Field<T> field, int rows, int columns)
Create a data array in blocks layout.

This method can be used to create the array argument of the `BlockFieldMatrix(int, int, FieldElement[][], boolean)` constructor.

Type Parameters:
  `T` - Type of the field elements.
Parameters:
  `field` - Field to which the elements belong.
  `rows` - Number of rows in the new matrix.
  `columns` - Number of columns in the new matrix.
Returns:
  a new data array in blocks layout.
See Also:
  - `toBlocksLayout(FieldElement[][])`
  - `BlockFieldMatrix(int, int, FieldElement[][], boolean)`

### createMatrix

public FieldMatrix<T> createMatrix(int rowDimension, int columnDimension) throws NotStrictlyPositiveException
Create a new FieldMatrix<T> of the same type as the instance with the supplied row and column dimensions.

Specified by:
  `createMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `createMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `rowDimension` - the number of rows in the new matrix
  `columnDimension` - the number of columns in the new matrix
Returns:
  a new matrix of the same type as the instance
Throws:
  `NotStrictlyPositiveException` - if row or column dimension is not positive.

### copy

public FieldMatrix<T> copy()
Make a (deep) copy of this.

Specified by:
  `copy` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `copy` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Returns:
  a copy of this matrix.

### add

public FieldMatrix<T> add(FieldMatrix<T> m) throws MatrixDimensionMismatchException
Compute the sum of this and m.

Specified by:
  `add` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `add` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `m` - Matrix to be added.
Returns:
  `this` + `m`.
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this` matrix.

### add

public BlockFieldMatrix<T> add(BlockFieldMatrix<T> m) throws MatrixDimensionMismatchException
Compute the sum of `this` and `m`.

Parameters:
  `m` - matrix to be added
Returns:
  `this + m`
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this`

### subtract

public FieldMatrix<T> subtract(FieldMatrix<T> m) throws MatrixDimensionMismatchException
Subtract `m` from this matrix.

Specified by:
  `subtract` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `subtract` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `m` - Matrix to be subtracted.
Returns:
  `this` - `m`.
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this` matrix.

### subtract

public BlockFieldMatrix<T> subtract(BlockFieldMatrix<T> m) throws MatrixDimensionMismatchException
Compute `this - m`.

Parameters:
  `m` - matrix to be subtracted
Returns:
  `this - m`
Throws:
  `MatrixDimensionMismatchException` - if `m` is not the same size as `this`

### scalarAdd

public FieldMatrix<T> scalarAdd(T d)
Increment each entry of this matrix.

Specified by:
  `scalarAdd` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `scalarAdd` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `d` - Value to be added to each entry.
Returns:
  `d` + `this`.

### scalarMultiply

public FieldMatrix<T> scalarMultiply(T d)
Multiply each entry by `d`.

Specified by:
  `scalarMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `scalarMultiply` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `d` - Value to multiply all entries by.
Returns:
  `d` * `this`.

### multiply

public FieldMatrix<T> multiply(FieldMatrix<T> m) throws DimensionMismatchException
Postmultiply this matrix by `m`.

Specified by:
  `multiply` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `multiply` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `m` - Matrix to postmultiply by.
Returns:
  `this` * `m`.
Throws:
  `DimensionMismatchException` - if the number of columns of `this` matrix is not equal to the number of rows of matrix `m`.

### multiply

public BlockFieldMatrix<T> multiply(BlockFieldMatrix<T> m) throws DimensionMismatchException
Returns the result of postmultiplying `this` by `m`.

Parameters:
  `m` - matrix to postmultiply by
Returns:
  `this * m`
Throws:
  `DimensionMismatchException` - if the matrices are not compatible.

### getData

public T[][] getData()
Returns matrix entries as a two-dimensional array.

Specified by:
  `getData` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getData` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Returns:
  a 2-dimensional array of entries.

### getSubMatrix

public FieldMatrix<T> getSubMatrix(int startRow, int endRow, int startColumn, int endColumn) throws OutOfRangeException, NumberIsTooSmallException
Get a submatrix. Rows and columns are indicated counting from 0 to n - 1.

Specified by:
  `getSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getSubMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  the matrix containing the data of the specified rows and columns.
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - is `endRow < startRow` of `endColumn < startColumn`.

### setSubMatrix

public void setSubMatrix(T[][] subMatrix, int row, int column) throws DimensionMismatchException, OutOfRangeException, NoDataException, NullArgumentException
Replace the submatrix starting at `(row, column)` using data in the input `subMatrix` array. Indexes are 0-based.

Example:
Starting with

     1  2  3  4
     5  6  7  8
     9  0  1  2

and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

     1  2  3  4
     5  3  4  8
     9  5  6  2

Specified by:
  `setSubMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setSubMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `subMatrix` - Array containing the submatrix replacement data.
  `row` - Row coordinate of the top-left element to be replaced.
  `column` - Column coordinate of the top-left element to be replaced.
Throws:
  `DimensionMismatchException` - if `subMatrix` is not rectangular (not all rows have the same length).
  `OutOfRangeException` - if `subMatrix` does not fit into this matrix from element in `(row, column)`.
  `NoDataException` - if a row or column of `subMatrix` is empty.
  `NullArgumentException` - if `subMatrix` is `null`.

### getRowMatrix

public FieldMatrix<T> getRowMatrix(int row) throws OutOfRangeException
Get the entries in row number `row` as a row matrix.

Specified by:
  `getRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getRowMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be fetched.
Returns:
  a row matrix.
Throws:
  `OutOfRangeException` - if the specified row index is invalid.

### setRowMatrix

public void setRowMatrix(int row, FieldMatrix<T> matrix) throws MatrixDimensionMismatchException, OutOfRangeException
Set the entries in row number `row` as a row matrix.

Specified by:
  `setRowMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setRowMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be set.
  `matrix` - Row matrix (must have one row and the same number of columns as the instance).
Throws:
  `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance row.
  `OutOfRangeException` - if the specified row index is invalid.

### setRowMatrix

public void setRowMatrix(int row, BlockFieldMatrix<T> matrix) throws MatrixDimensionMismatchException, OutOfRangeException
Sets the entries in row number `row` as a row matrix. Row indices start at 0.

Parameters:
  `row` - the row to be set
  `matrix` - row matrix (must have one row and the same number of columns as the instance)
Throws:
  `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance row.
  `OutOfRangeException` - if the specified row index is invalid.

### getColumnMatrix

public FieldMatrix<T> getColumnMatrix(int column) throws OutOfRangeException
Get the entries in column number `column` as a column matrix.

Specified by:
  `getColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getColumnMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - Column to be fetched.
Returns:
  a column matrix.
Throws:
  `OutOfRangeException` - if the specified column index is invalid.

### setColumnMatrix

public void setColumnMatrix(int column, FieldMatrix<T> matrix) throws MatrixDimensionMismatchException, OutOfRangeException
Set the entries in column number `column` as a column matrix.

Specified by:
  `setColumnMatrix` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setColumnMatrix` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - Column to be set.
  `matrix` - column matrix (must have one column and the same number of rows as the instance).
Throws:
  `MatrixDimensionMismatchException` - if the matrix dimensions do not match one instance column.
  `OutOfRangeException` - if the specified column index is invalid.

### getRowVector

public FieldVector<T> getRowVector(int row) throws OutOfRangeException
Get the entries in row number `row` as a vector.

Specified by:
  `getRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getRowVector` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be fetched
Returns:
  a row vector.
Throws:
  `OutOfRangeException` - if the specified row index is invalid.

### setRowVector

public void setRowVector(int row, FieldVector<T> vector) throws MatrixDimensionMismatchException, OutOfRangeException
Set the entries in row number `row` as a vector.

Specified by:
  `setRowVector` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setRowVector` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be set.
  `vector` - row vector (must have the same number of columns as the instance).
Throws:
  `MatrixDimensionMismatchException` - if the vector dimension does not match one instance row.
  `OutOfRangeException` - if the specified row index is invalid.

### getColumnVector

public FieldVector<T> getColumnVector(int column) throws OutOfRangeException
Returns the entries in column number `column` as a vector.

Specified by:
  `getColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getColumnVector` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - Column to be fetched.
Returns:
  a column vector.
Throws:
  `OutOfRangeException` - if the specified column index is invalid.

### setColumnVector

public void setColumnVector(int column, FieldVector<T> vector) throws OutOfRangeException, MatrixDimensionMismatchException
Set the entries in column number `column` as a vector.

Specified by:
  `setColumnVector` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setColumnVector` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - Column to be set.
  `vector` - Column vector (must have the same number of rows as the instance).
Throws:
  `OutOfRangeException` - if the specified column index is invalid.
  `MatrixDimensionMismatchException` - if the vector dimension does not match one instance column.

### getRow

public T[] getRow(int row) throws OutOfRangeException
Get the entries in row number `row` as an array.

Specified by:
  `getRow` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getRow` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be fetched.
Returns:
  array of entries in the row.
Throws:
  `OutOfRangeException` - if the specified row index is not valid.

### setRow

public void setRow(int row, T[] array) throws OutOfRangeException, MatrixDimensionMismatchException
Set the entries in row number `row` as a row matrix.

Specified by:
  `setRow` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setRow` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row to be set.
  `array` - Row matrix (must have the same number of columns as the instance).
Throws:
  `OutOfRangeException` - if the specified row index is invalid.
  `MatrixDimensionMismatchException` - if the array size does not match one instance row.

### getColumn

public T[] getColumn(int column) throws OutOfRangeException
Get the entries in column number `col` as an array.

Specified by:
  `getColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `getColumn` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - the column to be fetched
Returns:
  array of entries in the column
Throws:
  `OutOfRangeException` - if the specified column index is not valid.

### setColumn

public void setColumn(int column, T[] array) throws MatrixDimensionMismatchException, OutOfRangeException
Set the entries in column number `column` as a column matrix.

Specified by:
  `setColumn` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `setColumn` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `column` - the column to be set
  `array` - column array (must have the same number of rows as the instance)
Throws:
  `MatrixDimensionMismatchException` - if the array size does not match one instance column.
  `OutOfRangeException` - if the specified column index is invalid.

### getEntry

public T getEntry(int row, int column) throws OutOfRangeException
Returns the entry in the specified row and column.

Specified by:
  `getEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `getEntry` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - row location of entry to be fetched
  `column` - column location of entry to be fetched
Returns:
  matrix entry in row,column
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

### setEntry

public void setEntry(int row, int column, T value) throws OutOfRangeException
Set the entry in the specified row and column.

Specified by:
  `setEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `setEntry` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - row location of entry to be set
  `column` - column location of entry to be set
  `value` - matrix entry to be set in row,column
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

### addToEntry

public void addToEntry(int row, int column, T increment) throws OutOfRangeException
Change an entry in the specified row and column.

Specified by:
  `addToEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `addToEntry` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row location of entry to be set.
  `column` - Column location of entry to be set.
  `increment` - Value to add to the current matrix entry in `(row, column)`.
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

### multiplyEntry

public void multiplyEntry(int row, int column, T factor) throws OutOfRangeException
Change an entry in the specified row and column.

Specified by:
  `multiplyEntry` in interface `FieldMatrix<T extends FieldElement<T>>`
Specified by:
  `multiplyEntry` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `row` - Row location of entry to be set.
  `column` - Column location of entry to be set.
  `factor` - Multiplication factor for the current matrix entry in `(row,column)`
Throws:
  `OutOfRangeException` - if the row or column index is not valid.

### transpose

public FieldMatrix<T> transpose()
Returns the transpose of this matrix.

Specified by:
  `transpose` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `transpose` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Returns:
  transpose matrix

### getRowDimension

public int getRowDimension()
Returns the number of rows in the matrix.

Specified by:
  `getRowDimension` in interface `AnyMatrix`
Specified by:
  `getRowDimension` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Returns:
  rowDimension

### getColumnDimension

public int getColumnDimension()
Returns the number of columns in the matrix.

Specified by:
  `getColumnDimension` in interface `AnyMatrix`
Specified by:
  `getColumnDimension` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Returns:
  columnDimension

### operate

public T[] operate(T[] v) throws DimensionMismatchException
Returns the result of multiplying this by the vector `v`.

Specified by:
  `operate` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `operate` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `v` - the vector to operate on
Returns:
  `this * v`
Throws:
  `DimensionMismatchException` - if the number of columns of `this` matrix is not equal to the size of the vector `v`.

### preMultiply

public T[] preMultiply(T[] v) throws DimensionMismatchException
Returns the (row) vector result of premultiplying this by the vector `v`.

Specified by:
  `preMultiply` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `preMultiply` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `v` - the row vector to premultiply by
Returns:
  `v * this`
Throws:
  `DimensionMismatchException` - if the number of rows of `this` matrix is not equal to the size of the vector `v`

### walkInRowOrder

public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor)
Visit (and possibly change) all matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInRowOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor)
Visit (but don't change) all matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInRowOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

public T walkInRowOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn) throws OutOfRangeException, NumberIsTooSmallException
Visit (and possibly change) some matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInRowOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index
Returns:
  the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

public T walkInRowOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn) throws OutOfRangeException, NumberIsTooSmallException
Visit (but don't change) some matrix entries in row order.

Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

Specified by:
  `walkInRowOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInRowOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index
Returns:
  the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor)
Visit (and possibly change) all matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInOptimizedOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor)
Visit (but don't change) all matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInOptimizedOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
Returns:
  the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

public T walkInOptimizedOrder(FieldMatrixChangingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn) throws OutOfRangeException, NumberIsTooSmallException
Visit (and possibly change) some matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInOptimizedOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  the value returned by `FieldMatrixChangingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

public T walkInOptimizedOrder(FieldMatrixPreservingVisitor<T> visitor, int startRow, int endRow, int startColumn, int endColumn) throws OutOfRangeException, NumberIsTooSmallException
Visit (but don't change) some matrix entries using the fastest possible order.

The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

Specified by:
  `walkInOptimizedOrder` in interface `FieldMatrix<T extends FieldElement<T>>`
Overrides:
  `walkInOptimizedOrder` in class `AbstractFieldMatrix<T extends FieldElement<T>>`
Parameters:
  `visitor` - visitor used to process all matrix entries
  `startRow` - Initial row index
  `endRow` - Final row index (inclusive)
  `startColumn` - Initial column index
  `endColumn` - Final column index (inclusive)
Returns:
  the value returned by `FieldMatrixPreservingVisitor.end()` at the end of the walk
Throws:
  `OutOfRangeException` - if the indices are not valid.
  `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
See Also:
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInRowOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixChangingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInColumnOrder(FieldMatrixPreservingVisitor, int, int, int, int)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixPreservingVisitor)`
  - `FieldMatrix.walkInOptimizedOrder(FieldMatrixChangingVisitor, int, int, int, int)`